/* 

Widget Code!

*/

// Recursive Pos of div in document - should work in most browsers
function findPos(obj) {
	var curLeft = curTop = 0;
	if(obj.offsetParent) {
		curLeft = obj.offsetLeft
		curTop = obj.offsetTop
		while(obj = obj.offsetParent) {
			curLeft += obj.offsetLeft
			curTop += obj.offsetTop
		}
	}
	return {
		x:curLeft,
		y:curTop
	}
}

/*

ui read widget functions

*/

function readSlider(sliderId) {
	var value = parseFloat(document.getElementById(sliderId + "box").value);
	if(isNaN(value)) {
		value = 0.0;
	}
	return value;
}

function readBinary(binaryId) {
	lf = document.getElementById(binaryId + "marker").style.left;
	if(lf == "2px") {
		return 0;
	} else {
		return 1;
	}
}

/*

ui change widget functions

*/

// The idea is to have a few functions like this one and minimum javascript intervention		
function updateBinary(event, binaryId) {
	if(mb) {
		coords = findPos(event.currentTarget);
		coords.x = event.clientX - coords.x;
		coords.y = event.clientY - coords.y;
		if(coords.x > 24) {
			document.getElementById(binaryId + "marker").style.left = 20 + "px";										
			document.getElementById(binaryId).style.backgroundColor = "#ddd";										
		}else if(coords.x < 16) {
			document.getElementById(binaryId + "marker").style.left = 2 + "px";																		
			document.getElementById(binaryId).style.backgroundColor = "#777";										
		}
	}
}

// The idea is to have a few functions like this one and minimum javascript intervention		
function updateSlider(event, kind, min, max, length, sliderId, boxId) {
	if(mb) {
		coords = findPos(event.currentTarget);
		coords.x = event.clientX - coords.x;
		coords.y = event.clientY - coords.y;
		cx = coords.x / length;
		sd = max - min;
		value = min + (sd * cx);	
		if(value > max) value = max;
		if(kind == 0) {
			value = Math.round(value);
		}
		if(kind == 1) {
			value = Math.round(value * 10.0) / 10.0;
		}
		if(kind == 2) {
			value = Math.round(value * 100.0) / 100.0;
		}
		if(kind == 3) {
			value = Math.round(value * 1000.0) / 1000.0;
		}
		document.getElementById(boxId).value = value;				
		document.getElementById(sliderId).style.left = Math.ceil((length) * ((value - min) / sd)) + "px";
	}
}
		
function sliderPosition(value, min, max, length) {
		if(value < min) {
			value = min;
		}
		if(value > max) {
			value = max;
		}
		pos = Math.round(((value - min) / (max - min)) * length);
		return pos;
}

function changeSlider(value, sliderId, kind, min, max, length) {
		value = parseFloat(value);		
		if(isNaN(value)) {
			value = 0.0;
		}
		if(value < min) {
			value = min;
		}
		if(value > max) {
			value = max;
		}
		if(kind == 0) {
			value = Math.round(value);
		}
		if(kind == 1) {
			value = Math.round(value * 10.0) / 10.0;
		}
		if(kind == 2) {
			value = Math.round(value * 100.0) / 100.0;
		}
		if(kind == 3) {
			value = Math.round(value * 1000.0) / 1000.0;
		}
		pos = sliderPosition(value, min, max, length);
		document.getElementById(sliderId + "box").value = value;
		document.getElementById(sliderId + "marker").style.left = pos + "px";										
}

/*

ui make widget functions

*/

function makeLabel(name) {
	s = "";
	s += "<div class='label'>" + name + "</div>";
	return s;		
}

function makePanel(width, height) {
	s = "";		
	s += "<div class='panel' style='height: " + height + "px; width: " + width + "px;'>";
	return s;
}

function makePanelEnd() {
	s = "</div>";
	return s;		
}

function makeSlider(sliderId, kind, minValue, maxValue, midValue, sliderWidth, defaultValue) {
	s = "";
	defaultPosition = sliderPosition(defaultValue, minValue, maxValue, sliderWidth);
	if(defaultValue < minValue) {
		defaultValue = minValue;
	}
	if(defaultValue > maxValue) {
		defaultValue = maxValue;
	}					
	s += "<input id='" + sliderId + "box' value='" + defaultValue + "' type='text' class='sliderBox' onBlur='changeSlider(this.value,\"" + sliderId + "\"," + kind + "," + minValue + "," + maxValue + "," + sliderWidth + ");'>";
	s += "<div id='" + sliderId + "' class='sliderLine' style='width:" + sliderWidth + "px;'";
	s += " onmousemove='updateSlider(event," + kind + "," + minValue + "," + maxValue + "," + sliderWidth + ",\"" + sliderId + "marker\",\"" + sliderId + "box\");'";
	s += " onmouseup='updateSlider(event," + kind + "," + minValue + "," + maxValue + "," + sliderWidth + ",\"" + sliderId + "marker\",\"" + sliderId + "box\");'>";
	s += " <div id='" + sliderId + "marker' class='sliderMarker' style='left:" + defaultPosition + "px;'></div>";
	s += "</div>";
	s += "<div class='slidermidValue' style='width:" + sliderWidth + "px;'>" + midValue;
	s += "<div class='sliderminValue'>" + minValue + "</div>";
	s += "<div class='slidermaxValue'>" + maxValue + "</div></div>";
	return s;
}

function makeBinary(binaryId, defaultValue) {
	s = "";
	if(defaultValue == 1) {
		defaultPosition = 20;
		defaultColor = "#ddd";
	} else {
		defaultPosition = 2;
		defaultColor = "#777";
	}
	s += "<div id='" + binaryId + "' class='binaryLine' style='background-color:" + defaultColor + ";' onmousemove='updateBinary(event,\"" + binaryId + "\");' onmouseup='updateBinary(event,\"" + binaryId + "\");'>";
	s += "<div id='" + binaryId + "marker' class='binaryMarker' style='left:" + defaultPosition + "px;'></div>";
	s += "</div>";
	return s;
}

var mb = 0;

function mbPress(event) {
	mb = 1;
}

function mbRelease(event) {
	mb = 0;
}