<?php

class Admin extends CI_Controller {


	public function index() {
		$this->load->model('admin/Admin_model');
		$courses = $this->Admin_model->getCourses();
		$this->load->view('admin/header', array("title" => "Index"));
		$this->load->view('admin/index', array("courses" => $courses));
	}

	public function addCourse(){
		
		if(!isset($_POST['cid'])){
			$this->load->helper('form');
			$this->load->view('admin/header', array("title" => "Add course"));
			$this->load->view('admin/add_course');
		} else {
			$this->load->model('admin/Admin_model');
			$this->Admin_model->addCourse($_POST['cid'], $_POST['name']);
			redirect("admin/");
		}
	}

	public function manageCourse($cid) {
		$this->load->model('admin/Admin_model');
		$examples = $this->Admin_model->getExamples($cid);
		$this->load->view('admin/header', array("title" => "Manage course - ".$cid));
		$this->load->view('admin/manage_course', array("examples" => $examples, "cid" => $cid));
	}

	public function addExample($cid){
		
		if(!isset($_POST['example'])){
			$this->load->helper('form');
			$this->load->view('admin/header', array("title" => "Add example"));
			$this->load->view('admin/add_example', array("cid" => $cid));
		} else {
			$this->load->model('admin/Admin_model');
			$this->Admin_model->addExample($_POST['cid'], $_POST['example']);
			redirect("admin/");
		}
	}

	public function manageExample($cid, $example) {
		$this->load->model('admin/Admin_model');
		$pages = $this->Admin_model->getPages($cid, $example);
		$this->load->view('admin/header', array("title" => "Manage example - ".$example." - ".$cid));
		$this->load->view('admin/manage_example', array("pages" => $pages, "cid" => $cid, "example" => $example));
	}

	public function addPage($cid, $example){
		
		if(!isset($_POST['page'])){
			$this->load->helper('form');
			$this->load->view('admin/header', array("title" => "Add page"));
			$this->load->view('admin/add_page', array("cid" => $cid, "example" => $example));
		} else {
			$this->load->model('admin/Admin_model');
			$this->Admin_model->addPage($_POST['cid'], $_POST['example'],$_POST['page'], $_POST['documentation']);
			redirect("admin/");
		}
	}

	public function managePage($cid, $example, $page) {
		if(!isset($_POST['documentation'])){
			$this->load->helper('form');

			$this->load->model('codeviewer/Codeviewer_model');

			$files = $this->Codeviewer_model->getFiles($cid, $example,$page);
			$editorHTML = "";
			foreach ($files as $file) {
				$editorHTML .= $this->Codeviewer_model->showFile($file, "html");
			}

			$doc = $this->Codeviewer_model->getDoc($cid, $example, $page);

			$this->load->view('admin/header', array("editors" => $editorHTML, "title" => "Manage page - ".$page." - ".$example." - ".$cid));
			$this->load->view('admin/manage_page', array("cid" => $cid, "example" => $example, "page" => $page, "documentation" => $doc));
		} else {
			$this->load->model('admin/Admin_model');
			$this->Admin_model->updatePage($_POST['cid'], $_POST['example'],$_POST['page'], $_POST['documentation']);
			redirect("admin/");
		}
	}

	public function uploadFile($cid, $example, $page) {
		$this->load->model('admin/Admin_model');
		$this->Admin_model->uploadFile($_FILES['files'],$cid, $example, $page);
	}

}